# M5_TMC2130

Тест драйвера и описание его настройки



Общее:

Без радиатора будет греться до 75 градусов<br/>
С радиатором 65<br/>
Обдув решает все вопросы. Обдув обязателен<br/>
Как и в предыдущих версиях драйверов не рекомендуется отключать двигатель при включенном питании драйвера (необзодимо предотвратить самостоятельное отключение)<br/>

...............................................
<strong>- понятная распиновка/соединение для работы по SPI без промежуточных плат между ардуиной и TMC2130
</strong>
<br/>
Первый запуск (Для SPI режима)<br/>
Перед запуском необходимо убедится что драйвер не имеет перемычки на контактах SPI<br/>
Убедиться что правильно припаяны резисторы на контактах CFG4 (GND), CFG5 (VCC).<br/>
<strong> После этого подстроечный резистор перестает влиять на работу драйвера, ток выставляется в прошивке. </strong>
<br/>
В прошивке опытным путем было определено: Лучше использовать программный SPI, так как он учитывает все входы которые в аппаратном SPI необходимо подключить вручную к питанию Vio, GND или выставить необходимый уровень (DIR, STEP, EN) которыми возможно управлять в коде. Индивидуально необходимо рассматривать данные пины при использовании шилда.

<br/>
В файле TMC2130Stepper.h 410 строка необходимо изменить пины: 

<br/>
<b>Лучше всего использовать совместно с BIGTREETECH protector
Это шилд между драйвером и любой платой управления для защиты драйвера от перегорания при обрыве части контаков двигателя, или ручной прокрутки двигателей. В общем это защита драйвера от токов которые может генерировать мотор.
</b>
<br/>
<b>Еще лучше использовать готовую плату SKR v1.3 которая приходит по умолчанию настроенная на использование данных драйверов</b>



..................................<br/>.............
<strong> - понимание по подстройке ограничителя тока на TMC2130   </strong>
<br/>
<strong> После перевода в режим SPI подстроечный резистор перестает влиять на работу драйвера, ток выставляется в прошивке. </strong>
<br/>
Изначально необходимо знать характеристики мотора (используемого)
                 <br/>                               
модель: JK42HS34-1334AC<br/>
Распиновка: зеленый А+, черный А-, синий В+, красный В-.<br/>
угол поворота за один шаг: 1.8 º<br/>
<b>НОМИНАЛЬНЫЙ ток на обмотку: 1.33 А</b><br/>
сопротивление обмотки: 2.1 Ом по факту 3 Ом<br/>
индуктивность обмотки: 2.5 мГн<br/>
крутящий момент удержания: 2.2 кг/см<br/>
<br/><br/>
Верная настройка токов позволяет: <br/>
Избавится от пропуска шагов<br/>
Снизить нагрев двигателей<br/>
Снизить шум двигателей<br/>

<br/>
Как результат надо:<br/>


- выбор библиотеки и экземплы по обработке детектов (stallGuard2)<br/>

Когда подвижный механизм упирается в препятствие, нагрузка двигателя возрастает, что и обнаруживает stallGuard2<br/>
Схема измерения определяет электрическую энергию, подаваемую в двигатель (EI) и энергию, которая возвращается в источник питания (EB). Разница между этими показателями определяет энергию, которая была передана механической системе (EM). stallGuard2 контролирует значение EB, и, если оно приближается к нулю, это значит, что вся энергия передается в систему и подвижный механизм, скорее всего, уперся в препятствие.


<br/><br/>



Чтобы можно было отталкиваться от этого для применения где либо и написания прикладного кода.
Возможно на основе этого статью сделаем или видео. т.к. В инете похоже мало элементарных how to по этому драйверу, все что попадалось ориентировано на использование в конкретных 3д принтерах.

<br/>

<br/>

Ссылки: 
<br/>
Интересынй пример: https://revspace.nl/TMC2130<br/>
Библиотека: https://github.com/teemuatlut/TMC2130Stepper<br/>
https://github.com/teemuatlut/TMC2130Stepper/tree/master/examples <br/>
Про StallGuard2:   https://3dtoday.ru/blogs/svs0724/tms2130-applied-technology-and-connection-to-ruramps4d-in-the-configur/<br/>

